{% comment %}
  For Multi-Check Box with Search Box
{% endcomment %}

$.widget('ui.mcbselect', {
        version: '1.0.0',
        options: {
                width: '20em',
                height: '10em',
                __dummy__: 1
        },
        _create: function() {
                var $element = this.element;
                var options = this.options;

                $element.addClass('c-ui-mcbselect');
                $element.css({
                        width: options.width,
                        height: options.height});
                $element.find('input:checkbox').each(function() {
                        var $cb = $(this);
                        $cb
                        .on('change', function() {
                                if ($cb.prop('checked')) {
                                        $cb.parent().addClass('c-ui-mcbselect-on');
                                } else {
                                        $cb.parent().removeClass('c-ui-mcbselect-on');
                                }
                        })
                        .trigger('change');

                        {# FIXME: IE とそれ以外で change イベントの発生順が異なっていたため応急処置 #}
                        setInterval(function() {
                                if ($cb.prop('checked')) {
                                        $cb.parent().addClass('c-ui-mcbselect-on');
                                } else {
                                        $cb.parent().removeClass('c-ui-mcbselect-on');
                                }
                        }, 50);
                });
        },
        __dummy__: 1
})

$(function() {

	try {
		$('.mcbselect').mcbselect();
		$('#id_search').width($('.mcbselect').width()-6);
	} catch(e) {}

	function searchSelect() {
		var matchCase = $('#id_matchcasecheckbox').prop('checked');
		var searchKey = $('#id_search').val();
		$('#id_sharebox label')
			.each(function(i) {
				var choiceValue = $(this).find('input').val();
				if (!matchCase) {
					searchKey = searchKey.toLowerCase();
					choiceValue = choiceValue.toLowerCase();
				}
				if (choiceValue.indexOf(searchKey) != -1) {
					$(this).show();
				} else {
					$(this).hide();
				}
			});
	}
	$('#id_search')
		.on('keyup', function(e) {
			searchSelect();
		});
	$('#id_matchcasecheckbox')
		.on('change', function(e) {
			searchSelect();
		});

});
